#include <iostream>
#include <bits/stdc++.h>

using namespace std;

#define ll long long

ll gcd(ll a, ll b) {
    if (a < b)
        swap(a, b);
    if (b == 0)
        return a;
    return gcd(b, a % b);
}

struct st {
    struct Node {
        ll x1, y1, x2, y2, sum, all;
        bool fill;
        Node *LU, *RU, *LD, *RD;

        Node(ll _x1, ll _y1, ll _x2, ll _y2) {
            x1 = _x1, y1 = _y1, x2 = _x2, y2 = _y2;
            LU = RU = LD = RD = nullptr;
            sum = fill = false;
            all = (x2 - x1) * (y2 - y1);
        }
    };

    Node *root;

    const ll sz = 100000000000000ll;
    //ll sz = 3;

    st() {
        root = new Node(-sz, -sz, sz, sz);
    }

    void push(Node *r) {
        if (r->LD == nullptr) {
            ll mx = (r->x1 + r->x2) / 2;
            ll my = (r->y1 + r->y2) / 2;
            r->LU = new Node(r->x1, r->y1, mx, my);
            r->RU = new Node(mx, r->y1, r->x2, my);
            r->LD = new Node(r->x1, my, mx, r->y2);
            r->RD = new Node(mx, my, r->x2, r->y2);
        }
        if (r->fill) {
            r->LU->fill = r->RU->fill = r->LD->fill = r->RD->fill = 1;
            r->LU->sum = r->LU->all;
            r->RU->sum = r->RU->all;
            r->LD->sum = r->LD->all;
            r->RD->sum = r->RD->all;
        }
    }

    void merge(Node *r) {
        if (r->LD != nullptr)
            r->sum = r->LD->sum + r->LU->sum + r->RD->sum + r->RU->sum;
    }

    ll x1, y1, x2, y2;

    void fil(ll _x1, ll _y1, ll _x2, ll _y2) {
        x1 = _x1;
        x2 = _x2;
        y1 = _y1;
        y2 = _y2;
        fil(root);
    }

    void fil(Node *r) {
        if (r->x1 >= x1 && r->x2 <= x2 && r->y1 >= y1 && r->y2 <= y2) {
            r->fill = true;
            r->sum = r->all;
        } else if (r->x1 >= x2 || r->x2 <= x1 || r->y1 >= y2 || r->y2 <= y1) {
            return;
        } else if (!r->fill) {
            push(r);
            fil(r->LD);
            fil(r->LU);
            fil(r->RD);
            fil(r->RU);
            merge(r);
        }
    }

    ll ask(ll _x1, ll _y1, ll _x2, ll _y2) {
        x1 = _x1;
        x2 = _x2;
        y1 = _y1;
        y2 = _y2;
        return ask(root);
    }

    ll ask(Node *r) {
        if (r->x1 >= x1 && r->x2 <= x2 && r->y1 >= y1 && r->y2 <= y2)
            return r->sum;
        else if (r->x1 >= x2 || r->x2 <= x1 || r->y1 >= y2 || r->y2 <= y1)
            return 0;
        else {
            push(r);
            return ask(r->LD) + ask(r->LU) + ask(r->RD) + ask(r->RU);
        }
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    auto arr = new st();
    ll k, n;
    cin >> k >> n;
    char c;
    ll a;
    ll posx = 0;
    ll posy = 0;
    while (n--) {
        cin >> c >> a;
        if (c == 'N') {
            arr->fil(posx, posy-a, posx+k, posy+k);
            posy -= a;
        } else if (c == 'S') {
            arr->fil(posx, posy, posx+k, posy+k+a);
            posy += a;
        } else if (c == 'W') {
            arr->fil(posx-a, posy, posx+k, posy+k);
            posx -= a;
        } else {
            arr->fil(posx, posy, posx+k+a, posy+k);
            posx += a;
        }
    }
    cout << arr->root->sum;
}
/*
1 5
E 2
N 2
W 4
S 4
E 4

3 4
W 2
N 1
W 1
N 2

 */