#include <iostream>
#include <bits/stdc++.h>

using namespace std;

#define ll long long

struct st {
    struct Node {
        ll x1, x2, mi, cntmi, dlt;
        Node *L, *R;

        Node(ll _x1, ll _x2) {
            x1 = _x1, x2 = _x2, mi = dlt = 0, cntmi = x2 - x1;
            L = R = nullptr;
        }
    };

    Node *root;

    ll sz = 1000000000000000ll;

    st() {
        root = new Node(-sz, sz);
    }

    void dltadd(Node *r, ll v) {
        r->dlt += v;
        r->mi += v;
    }

    void push(Node *r) {
        if (r->L == nullptr) {
            r->L = new Node(r->x1, (r->x1 + r->x2) / 2);
            r->R = new Node((r->x1 + r->x2) / 2, r->x2);
        }
        if (r->dlt) {
            dltadd(r->L, r->dlt);
            dltadd(r->R, r->dlt);
            r->dlt = 0;
        }
    }

    void merge(Node *r) {
        if (r->L->mi == r->R->mi) {
            r->mi = r->L->mi;
            r->cntmi = r->L->cntmi + r->R->cntmi;
        } else if (r->L->mi < r->R->mi) {
            r->mi = r->L->mi;
            r->cntmi = r->L->cntmi;
        }else {
            r->mi = r->R->mi;
            r->cntmi = r->R->cntmi;
        }
    }

    ll x1, x2, d;
    void add(ll _l, ll _r, ll _d) {
        x1 = _l, x2 = _r, d = _d;
        add(root);
    }

    void add(Node *r) {
        if (r->x1 >= x1 && r->x2 <= x2)
            dltadd(r, d);
        else if (r->x1 >= x2 || r->x2 <= x1)
            return;
        else {
            push(r);
            add(r->L);
            add(r->R);
            merge(r);
        }
    }

    ll ask(ll _l, ll _r) {
        x1 = _l, x2 = _r;
        return ask(root);
    }

    ll ask(Node *r) {
        if (r->x1 >= x1 && r->x2 <= x2)
            return r->x2 - r->x1 - (r->mi == 0) * r->cntmi;
        else if (r->x1 >= x2 || r->x2 <= x1)
            return 0;
        else {
            push(r);
            return ask(r->L) + ask(r->R);
        }
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    // h = 48

    auto arr = new st();

    ll k, n;
    cin >> k >> n;
    vector<tuple<ll, ll, ll, ll>> ops; // cord x, ldt, x1, x2

    char c;
    ll a;
    ll posx = 0;
    ll posy = 0;

    while (n--) {
        cin >> c >> a;
        if (c == 'N') {
            ops.emplace_back(posx, 1, posy-a, posy+k);
            ops.emplace_back(posx+k, -1, posy-a, posy+k);
            posy -= a;
        } else if (c == 'S') {
            ops.emplace_back(posx, 1, posy, posy+k+a);
            ops.emplace_back(posx+k, -1, posy, posy+k+a);
            posy += a;
        } else if (c == 'W') {
            ops.emplace_back(posx-a, 1, posy, posy+k);
            ops.emplace_back(posx+k, -1, posy, posy+k);
            posx -= a;
        } else {
            ops.emplace_back(posx, 1, posy, posy+k);
            ops.emplace_back(posx+k+a, -1, posy, posy+k);
            posx += a;
        }
    }

    sort(ops.begin(), ops.end());
    ll lastcord = 0, ans = 0;
    for (auto t : ops) {
        ans += (get<0>(t)-lastcord) * (arr->root->x2 - arr->root->x1 - (arr->root->mi == 0) * arr->root->cntmi);
        lastcord = get<0>(t);
        arr->add(get<2>(t), get<3>(t), get<1>(t));
    }
    cout << ans;
}
/*
1 5
E 2
N 2
W 4
S 4
E 4

3 4
W 2
N 1
W 1
N 2


48 * 4 * 100000
 */